#ifndef MENU_H
#define MENU_H

#include "score.h"
#include "stars.h"
#include <vector>


class StartMenu {
	static StartMenu * singleton_;

	XFontStruct * font_;
	int text_width_;
	int wait_scores_;
	bool print_scores_;
	unsigned short green_comp_;
	short green_add_;

	StartMenu();
	~StartMenu();
	XColor NextColor();
	int LineHeight() const { return font_->ascent + font_->descent + 1; }
	void PrintHelp();
	void PrintScores();
public:
	static StartMenu & Instance() {
		if (!singleton_) singleton_ = new StartMenu;
		return *singleton_;
	}
	static void DestroyInstance() { delete singleton_; singleton_ = 0; }

	bool Display(std::vector<StarsField> * stars_fields,
	             Score * score);
};


#endif
