#include "time_util.h"

#include <time.h>
#include <sys/time.h>
#include <unistd.h>

#include <errno.h>


double CurrentMicroSecond()
{
	timeval nowSec;
	gettimeofday(&nowSec, 0);
	return nowSec.tv_sec + static_cast<double>(nowSec.tv_usec) / 1000000.0;
}


void WaitNextFrame(double start_time)
{
	// It is possible to get vertical frequency from XF86VidModeGetModeLine
	// but Linux does not have a precise enough timer to use it.
	const double vfreq = 50;
	const double frame_interval = 1000.0 * 1000 / vfreq;

	const double micro_elapsed(CurrentMicroSecond() - start_time);
	if (micro_elapsed < frame_interval) {
		timeval timeout;
		timeout.tv_sec = 0;
		timeout.tv_usec = static_cast<long>(frame_interval - micro_elapsed);
		while (select(0, NULL, NULL, NULL, &timeout) == -1 && errno == EINTR);
	}
}
